/// <reference types="node" />
import * as _fs from 'fs';
declare function copy(src: string, dist: string, opts?: {
    filter?: (stat: _fs.Stats) => boolean;
    override?: boolean;
}): Promise<void>;
export declare const fs: {
    access: typeof _fs.access.__promisify__;
    copyFile: typeof _fs.copyFile.__promisify__;
    open: typeof _fs.open.__promisify__;
    rename: typeof _fs.rename.__promisify__;
    truncate: typeof _fs.truncate.__promisify__;
    rmdir: typeof _fs.rmdir.__promisify__;
    mkdir: typeof _fs.mkdir.__promisify__;
    readdir: typeof _fs.readdir.__promisify__;
    readlink: typeof _fs.readlink.__promisify__;
    symlink: typeof _fs.symlink.__promisify__;
    lstat: typeof _fs.lstat.__promisify__;
    stat: typeof _fs.stat.__promisify__;
    link: (arg1: _fs.PathLike, arg2: _fs.PathLike) => Promise<void>;
    unlink: typeof _fs.unlink.__promisify__;
    chmod: typeof _fs.chmod.__promisify__;
    lchmod: typeof _fs.lchmod.__promisify__;
    lchown: typeof _fs.lchown.__promisify__;
    chown: typeof _fs.chown.__promisify__;
    utimes: typeof _fs.utimes.__promisify__;
    realpath: typeof _fs.realpath.__promisify__;
    mkdtemp: typeof _fs.mkdtemp.__promisify__;
    writeFile: typeof _fs.writeFile.__promisify__;
    appendFile: typeof _fs.appendFile.__promisify__;
    readFile: typeof _fs.readFile.__promisify__;
    existsSync: typeof _fs.existsSync;
    createReadString: typeof _fs.createReadStream;
    createWriteStream: typeof _fs.createWriteStream;
    constants: typeof _fs.constants;
    copy: typeof copy;
    /**
     * Make directory with parents, like `mkdir -p`
     * @param dir
     */
    mkdirp(dir: string): Promise<void>;
    /**
     * Remove file or directory recursively, like `rm -rf`
     * @param di
     */
    rmrf(path: string): Promise<void>;
    outputFile(path: string, data: any, options?: string | {
        encoding?: string;
        mode?: string | number;
        flag?: string;
    }): Promise<void>;
    outputFileSync(path: string, data: any, options?: string | {
        encoding?: string;
        mode?: string | number;
        flag?: string;
    }): Promise<void>;
    outputJson(path: string, data: object, options?: string | {
        encoding?: string;
        mode?: string | number;
        flag?: string;
    }): Promise<void>;
    outputJsonSync(path: string, data: object, options?: string | {
        encoding?: string;
        mode?: string | number;
        flag?: string;
    }): Promise<void>;
    readJson(path: string, options?: {
        encoding?: null;
        flag?: string;
    }): Promise<any>;
    readJsonSync(path: string, options?: {
        encoding?: null;
        flag?: string;
    }): Promise<any>;
    renameSync(oldPath: _fs.PathLike, newPath: _fs.PathLike): void;
    truncateSync(path: _fs.PathLike, len?: number): void;
    ftruncate: typeof _fs.ftruncate;
    ftruncateSync(fd: number, len?: number): void;
    chownSync(path: _fs.PathLike, uid: number, gid: number): void;
    fchown: typeof _fs.fchown;
    fchownSync(fd: number, uid: number, gid: number): void;
    lchownSync(path: _fs.PathLike, uid: number, gid: number): void;
    chmodSync(path: _fs.PathLike, mode: string | number): void;
    fchmod: typeof _fs.fchmod;
    fchmodSync(fd: number, mode: string | number): void;
    lchmodSync(path: _fs.PathLike, mode: string | number): void;
    statSync(path: _fs.PathLike): _fs.Stats;
    fstat: typeof _fs.fstat;
    fstatSync(fd: number): _fs.Stats;
    lstatSync(path: _fs.PathLike): _fs.Stats;
    linkSync(existingPath: _fs.PathLike, newPath: _fs.PathLike): void;
    symlinkSync(target: _fs.PathLike, path: _fs.PathLike, type?: _fs.symlink.Type): void;
    readlinkSync(path: _fs.PathLike, options?: "ascii" | "utf8" | "utf16le" | "ucs2" | "base64" | "latin1" | "binary" | "hex" | {
        encoding?: BufferEncoding;
    }): string;
    readlinkSync(path: _fs.PathLike, options: "buffer" | {
        encoding: "buffer";
    }): Buffer;
    readlinkSync(path: _fs.PathLike, options?: string | {
        encoding?: string;
    }): string | Buffer;
    realpathSync: typeof _fs.realpathSync;
    unlinkSync(path: _fs.PathLike): void;
    rmdirSync(path: _fs.PathLike): void;
    mkdirSync(path: _fs.PathLike, options?: string | number | _fs.MakeDirectoryOptions): void;
    mkdtempSync(prefix: string, options?: "ascii" | "utf8" | "utf16le" | "ucs2" | "base64" | "latin1" | "binary" | "hex" | {
        encoding?: BufferEncoding;
    }): string;
    mkdtempSync(prefix: string, options: "buffer" | {
        encoding: "buffer";
    }): Buffer;
    mkdtempSync(prefix: string, options?: string | {
        encoding?: string;
    }): string | Buffer;
    readdirSync(path: _fs.PathLike, options?: "ascii" | "utf8" | "utf16le" | "ucs2" | "base64" | "latin1" | "binary" | "hex" | {
        encoding: BufferEncoding;
        withFileTypes?: false;
    }): string[];
    readdirSync(path: _fs.PathLike, options: "buffer" | {
        encoding: "buffer";
        withFileTypes?: false;
    }): Buffer[];
    readdirSync(path: _fs.PathLike, options?: string | {
        encoding?: string;
        withFileTypes?: false;
    }): string[] | Buffer[];
    readdirSync(path: _fs.PathLike, options: {
        withFileTypes: true;
    }): _fs.Dirent[];
    close: typeof _fs.close;
    closeSync(fd: number): void;
    openSync(path: _fs.PathLike, flags: string | number, mode?: string | number): number;
    utimesSync(path: _fs.PathLike, atime: string | number | Date, mtime: string | number | Date): void;
    futimes: typeof _fs.futimes;
    futimesSync(fd: number, atime: string | number | Date, mtime: string | number | Date): void;
    fsync: typeof _fs.fsync;
    fsyncSync(fd: number): void;
    write: typeof _fs.write;
    writeSync(fd: number, buffer: _fs.BinaryData, offset?: number, length?: number, position?: number): number;
    writeSync(fd: number, string: any, position?: number, encoding?: string): number;
    read: typeof _fs.read;
    readSync(fd: number, buffer: _fs.BinaryData, offset: number, length: number, position: number): number;
    readFileSync(path: string | number | Buffer | import("url").URL, options?: {
        encoding?: null;
        flag?: string;
    }): Buffer;
    readFileSync(path: string | number | Buffer | import("url").URL, options: string | {
        encoding: string;
        flag?: string;
    }): string;
    readFileSync(path: string | number | Buffer | import("url").URL, options?: string | {
        encoding?: string;
        flag?: string;
    }): string | Buffer;
    writeFileSync(path: string | number | Buffer | import("url").URL, data: any, options?: _fs.WriteFileOptions): void;
    appendFileSync(file: string | number | Buffer | import("url").URL, data: any, options?: _fs.WriteFileOptions): void;
    watchFile(filename: _fs.PathLike, options: {
        persistent?: boolean;
        interval?: number;
    }, listener: (curr: _fs.Stats, prev: _fs.Stats) => void): void;
    watchFile(filename: _fs.PathLike, listener: (curr: _fs.Stats, prev: _fs.Stats) => void): void;
    unwatchFile(filename: _fs.PathLike, listener?: (curr: _fs.Stats, prev: _fs.Stats) => void): void;
    watch(filename: _fs.PathLike, options: "ascii" | "utf8" | "utf16le" | "ucs2" | "base64" | "latin1" | "binary" | "hex" | {
        encoding?: BufferEncoding;
        persistent?: boolean;
        recursive?: boolean;
    }, listener?: (event: string, filename: string) => void): _fs.FSWatcher;
    watch(filename: _fs.PathLike, options: "buffer" | {
        encoding: "buffer";
        persistent?: boolean;
        recursive?: boolean;
    }, listener?: (event: string, filename: Buffer) => void): _fs.FSWatcher;
    watch(filename: _fs.PathLike, options: string | {
        encoding?: string;
        persistent?: boolean;
        recursive?: boolean;
    }, listener?: (event: string, filename: string | Buffer) => void): _fs.FSWatcher;
    watch(filename: _fs.PathLike, listener?: (event: string, filename: string) => any): _fs.FSWatcher;
    exists: typeof _fs.exists;
    accessSync(path: _fs.PathLike, mode?: number): void;
    createReadStream(path: _fs.PathLike, options?: string | {
        flags?: string;
        encoding?: string;
        fd?: number;
        mode?: number;
        autoClose?: boolean;
        start?: number;
        end?: number;
        highWaterMark?: number;
    }): _fs.ReadStream;
    fdatasync: typeof _fs.fdatasync;
    fdatasyncSync(fd: number): void;
    copyFileSync(src: _fs.PathLike, dest: _fs.PathLike, flags?: number): void;
    Stats: typeof _fs.Stats;
    Dirent: typeof _fs.Dirent;
    ReadStream: typeof _fs.ReadStream;
    WriteStream: typeof _fs.WriteStream;
    promises: typeof _fs.promises;
};
export {};
